REM Provides a simple scope type display of the input. Only a logic input is
REM available, hence the trace is either high or low.
REM To alter the speed of sampling, simply alter the value of x in line 150.
REM This version requires you to experiment with this value, as it varies
REM between machines

REM Note that the scope is adequate for frequencies upto about 500 hz,
REM depending on you machine
    
REM set up the screen
10 SCREEN 12
20 CLS
30 LET b = 320

50 GOSUB 1000           ' draw the initial axis

REM samples the input
70 LET start = TIMER
80 FOR j = 20 TO 619
90 IF (j - 20) / 120 = INT((j - 20) / 120) THEN GOSUB 2000
100 LET a = STRIG(5)
110 LET a = 300 * a + 320

REM draws a vertical line when the input changes
120 IF a <> b THEN LINE (j, a)-(j, b): GOTO 140
130 LINE (j - 1, a)-(j, a)
140 LET b = a

REM the time delay; alter this to suit your sampling
150 FOR x = 1 TO 1
160 NEXT x

REM to next pixel
200 NEXT j

REM repaint the display area once the scope is filled
300 COLOR 0
310 LINE (20, 20)-(620, 320), , BF
320 COLOR 14
330 GOTO 70

1000 REM draw frame
1010 COLOR 9
1020 LINE (20, 360)-(620, 360)
1030 FOR i = 20 TO 620 STEP 60
1040 LINE (i, 360)-(i, 364)
1050 NEXT i
1060 FOR i = 20 TO 620 STEP 60
1070 LINE (i, 10)-(i, 14)
1080 NEXT i
1090 LINE (20, 10)-(620, 10)
1100 COLOR 14
1110 RETURN

REM  print the time
2000 REM
2010 LET ctime = TIMER - start
2020 LOCATE 25, (j / 7.5)
2050 LET ctime = INT(ctime * 100) / 100
2090 PRINT ctime
2100 RETURN


