REM This program gives a summary of the input data over time.
REM Output refers to the time that the input (strig 5) is high, and provides
REM a summary in the form of mean, standard deviation, standard error (std dev
REM divided by root n), and the coefficient of variation.
REM Not recommended for small time intervals (eg < 2s), as timing erros become
REM significant (eg the smallest jump on my machine was about 15-20 ms).

10 CLS
20 DIM a(1000): DIM b(1000) 'The max number of samples
40 INPUT "Number of samples"; n
50 IF n < 2 THEN GOTO 40
60 PRINT
70 INPUT "Path and name of file to be saved"; filename$

80 IF STRIG(5) = 0 THEN GOTO 80      'Must have -ve pulse to initialize
100 FOR i = 1 TO n
110 IF STRIG(5) = 0 THEN GOTO 110
120 start = TIMER
130 IF STRIG(5) = -1 THEN GOTO 130
140 a(i) = TIMER - start
150 PRINT a(i)
160 NEXT i

200 LET tot = 0: LET totss = 0: LET mini = 1000000: LET max = 0
210 FOR i = 1 TO n
220 LET tot = tot + a(i)
230 LET ss = a(i) * a(i): LET totss = totss + ss
240 IF a(i) > max THEN LET max = a(i)
250 IF a(i) < mini THEN LET mini = a(i)
270 NEXT i
280 LET mean = tot / n
290 PRINT
300 PRINT "Mean = "; mean
305 PRINT : IF mean = 0 THEN END
310 LET var = (totss / n - (mean ^ 2)) * (n / (n - 1))
320 PRINT "Variance = "; var
325 IF var < 0 THEN LET stdev = 0: GOTO 340
330 LET stdev = SQR(var)
340 PRINT "Standard deviation = "; stdev
350 LET sterr = stdev / SQR(n)
355 PRINT
360 PRINT "Standard error = "; sterr
370 LET cv = stdev / mean * 100
380 PRINT "Co-efficient of variation = "; cv
385 PRINT
390 PRINT "Minimum = "; mini
400 PRINT "Maximum = "; max
410 PRINT "Range = "; max - mini
420 PRINT
430 PRINT "Maximum departure above mean "; (max - mean) / mean * 100; "%"
440 PRINT "Maximum departure below the mean "; (mini - mean) / mean * 100; "%"

500 OPEN filename$ FOR OUTPUT AS #1
510 FOR j = 1 TO n
520 WRITE #1, a(j)
530 NEXT j
540 END











