REM This program records the times for which two inputs are either high or low.
REM The display gives the time at which an input changed state, and the length
REM of time for which it had previously been in that state.
REM The first input is assigned to the left hand column, the second to
REM the right.

REM Note that you may have to alter the value of strig() in lines 270 and 280
REM to suit your particular inputs.

REM set the intial variables
10 CLS
20 LET a = b = c = d = 0
30 LET con = 0

REM read first data
210 LET a = -1
220 LET c = -1
240 LOCATE 1, 1: GOSUB 500
250 LOCATE 1, 60: GOSUB 600
260 LOCATE 2, 1

REM data read here
270 LET b = STRIG(5)
280 LET d = STRIG(1)

REM does data match its previous value?
300 IF a <> b THEN GOSUB 500
310 IF c <> d THEN GOSUB 600
350 LET con = 1: REM The control variable
400 GOTO 270

REM decoding for the first channel
REM x shifts the display
500 LET x = 0
510 PRINT TIME$;
520 LET t = TIMER - startone
525 IF con = 0 THEN t = 0

REM subroutine at 1000 to display data
530 IF a = 0 THEN COLOR 9: y = 10: GOSUB 1000: COLOR 12: PRINT TAB(30); "High": GOTO 540
535 IF a = -1 THEN COLOR 12: y = 0: GOSUB 1000: COLOR 9: PRINT TAB(40); "Low "

REM equates the current and the 'previous' variable for future comparisons
540 LET a = b
580 startone = TIMER
590 COLOR 7: RETURN

REM decoding for the second channel
600 LET x = 30
610 IF con = 1 THEN PRINT TIME$;
620 LET t = TIMER - starttwo
630 IF c = 0 THEN COLOR 9: y = 10: GOSUB 1000: COLOR 12: PRINT TAB(60); "High": GOTO 640
635 IF c = -1 THEN COLOR 12: y = 0: GOSUB 1000: COLOR 9: PRINT TAB(70); "Low "
640 LET c = d
660 con = 1
670 REM IF con = 1 THEN LET t = timeone: GOSUB 1000
680 starttwo = TIMER
690 COLOR 7: RETURN

REM round the times to integral values
1000 IF t < 0 THEN LET t = t + 86400 ELSE t = t
1002 h = FIX(t / 3600)
1005 m = FIX((t - (h * 3600)) / 60)
1010 s = FIX(10 * (t - (h * 3600) - (m * 60))) / 10
1015 IF con = 0 THEN RETURN
1020 PRINT TAB(24 + y + x);

REM plots only the data that need be plotted
1030 IF h > 0 THEN GOTO 1070
1040 IF m > 0 THEN GOTO 1060
1050 PRINT "     "; s: GOTO 1100
1060 PRINT "  "; m; s: GOTO 1100
1070 PRINT h; m; s: GOTO 1100
1100 RETURN

