REM Similar to SCOPE.BAS, but requires a positive transition before any
REM recording starts. The image is then held until any key is pressed

REM sets up screen
10 SCREEN 12
20 CLS
30 LET b = 320

REM draw the axes
50 GOSUB 1000

REM to wait for the trigger
60 GOSUB 3000

REM calculate the times on the axis
70 LET start = TIMER
80 FOR j = 20 TO 619
90 IF (j - 20) / 120 = INT((j - 20) / 120) THEN GOSUB 2000         ' to update the times

REM read data
100 LET a = STRIG(5)
110 LET a = 300 * a + 320

REM draws a sharp vertical line
120 IF a <> b THEN LINE (j, a)-(j, b): GOTO 140
130 LINE (j - 1, a)-(j, a)
140 LET b = a

REM increase this number for a longer sampling period
150 FOR x = 1 TO 25
160 NEXT x

200 NEXT j         'Draws the next pixel
250 BEEP           ' At end of screen

REM wait to refresf screen
260 DO
270 LOOP UNTIL INKEY$ <> ""

REM erases the last screen
300 COLOR 0
310 LINE (19, 20)-(620, 320), , BF
320 COLOR 14
330 GOTO 60
    
1000 REM Draw frame
1010 COLOR 9
1020 LINE (20, 360)-(620, 360)
1030 FOR i = 20 TO 620 STEP 60           'Draw ticks
1040 LINE (i, 360)-(i, 364)
1050 NEXT i
1060 FOR i = 20 TO 620 STEP 60
1070 LINE (i, 10)-(i, 14)
1080 NEXT i
1090 LINE (20, 10)-(620, 10)
1100 COLOR 14
1120 LOCATE 28, 40
1130 PRINT "Seconds"
1200 RETURN

2000 REM prints the elapsed time
2010 LET ctime = TIMER - start
2020 LOCATE 25, (j / 7.5)
2050 LET ctime = INT(ctime * 100) / 100
2090 PRINT ctime
2100 RETURN

3000 REM triggering delay
3010 LET a = STRIG(5)
3020 LOCATE 28, 10
3060 PRINT "->"
3070 LOCATE 28, 10
3080 PRINT "    "
REM alter the next line for negative triggering
3090 IF a = 0 THEN GOTO 3010
3100 RETURN


